'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Logger = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _level = require('./level');

var _display = require('./display');

var _helpers = require('./helpers');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Logger = exports.Logger = function () {
    function Logger(name, color, developmentMode, allowed, isMuted, fixedWidth) {
        var _this = this;

        _classCallCheck(this, Logger);

        this.name = name;
        this.color = color;
        this.developmentMode = developmentMode;
        this.allowed = allowed;
        this.isMuted = isMuted;
        this.fixedWidth = fixedWidth;
        /** @deprecated Use data(...)
         * @see data
        */
        this.d = function (name) {
            for (var _len = arguments.length, data = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                data[_key - 1] = arguments[_key];
            }

            return _this._data(name, data);
        };
        /** @deprecated Use error(...)
         * @see error
        */
        this.er = function (name) {
            for (var _len2 = arguments.length, data = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                data[_key2 - 1] = arguments[_key2];
            }

            return _this._error(name, data);
        };
        /** @deprecated Use info(...)
         * @see info
        */
        this.i = function (name) {
            for (var _len3 = arguments.length, data = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                data[_key3 - 1] = arguments[_key3];
            }

            return _this._info(name, data);
        };
        /** @deprecated Use warn(...)
         * @see warn
        */
        this.w = function (name) {
            for (var _len4 = arguments.length, data = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
                data[_key4 - 1] = arguments[_key4];
            }

            return _this._warn(name, data);
        };
        /**
         * Logs message and data with the level=data
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.data = function (message) {
            for (var _len5 = arguments.length, otherParams = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
                otherParams[_key5 - 1] = arguments[_key5];
            }

            return _this._data(message, otherParams);
        };
        /**
         * Logs message and data with the level=error
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.error = function (message) {
            for (var _len6 = arguments.length, otherParams = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
                otherParams[_key6 - 1] = arguments[_key6];
            }

            return _this._error(message, otherParams);
        };
        /**
         * Logs message and data with the level=info
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.info = function (message) {
            for (var _len7 = arguments.length, otherParams = Array(_len7 > 1 ? _len7 - 1 : 0), _key7 = 1; _key7 < _len7; _key7++) {
                otherParams[_key7 - 1] = arguments[_key7];
            }

            return _this._info(message, otherParams);
        };
        /**
         * Logs message and data with the level=warn
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.warn = function (message) {
            for (var _len8 = arguments.length, otherParams = Array(_len8 > 1 ? _len8 - 1 : 0), _key8 = 1; _key8 < _len8; _key8++) {
                otherParams[_key8 - 1] = arguments[_key8];
            }

            return _this._warn(message, otherParams);
        };
    }

    _createClass(Logger, [{
        key: 'setLevel',
        value: function setLevel(l) {
            this._level = l;
            return this;
        }
    }, {
        key: 'setProductionMode',
        value: function setProductionMode(productionMode) {
            this.developmentMode = !productionMode;
            return this;
        }
    }, {
        key: 'mute',
        value: function mute() {
            this.isMuted = true;
            return this;
        }
    }, {
        key: 'onlyWhen',
        value: function onlyWhen(expression) {
            if (typeof expression === 'function') {
                this.isMuted = !expression();
            } else if (typeof expression === 'boolean') {
                this.isMuted = !expression;
            }
        }
    }, {
        key: '_data',
        value: function _data(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _helpers.Helpers.contain(this.allowed, _level.Level.__NOTHING) && !_helpers.Helpers.contain(this.allowed, _level.Level.DATA)) return this;
            if (this.allowed.length === 0 || _helpers.Helpers.contain(this.allowed, _level.Level.DATA)) {
                for (var _len9 = arguments.length, data = Array(_len9 > 1 ? _len9 - 1 : 0), _key9 = 1; _key9 < _len9; _key9++) {
                    data[_key9 - 1] = arguments[_key9];
                }

                _display.Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, _level.Level.DATA, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: '_error',
        value: function _error(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _helpers.Helpers.contain(this.allowed, _level.Level.__NOTHING) && !_helpers.Helpers.contain(this.allowed, _level.Level.ERROR)) return this;
            if (this.allowed.length === 0 || _helpers.Helpers.contain(this.allowed, _level.Level.ERROR)) {
                for (var _len10 = arguments.length, data = Array(_len10 > 1 ? _len10 - 1 : 0), _key10 = 1; _key10 < _len10; _key10++) {
                    data[_key10 - 1] = arguments[_key10];
                }

                _display.Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, _level.Level.ERROR, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: '_info',
        value: function _info(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _helpers.Helpers.contain(this.allowed, _level.Level.__NOTHING) && !_helpers.Helpers.contain(this.allowed, _level.Level.INFO)) return this;
            if (this.allowed.length === 0 || _helpers.Helpers.contain(this.allowed, _level.Level.INFO)) {
                for (var _len11 = arguments.length, data = Array(_len11 > 1 ? _len11 - 1 : 0), _key11 = 1; _key11 < _len11; _key11++) {
                    data[_key11 - 1] = arguments[_key11];
                }

                _display.Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, _level.Level.INFO, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: '_warn',
        value: function _warn(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _helpers.Helpers.contain(this.allowed, _level.Level.__NOTHING) && !_helpers.Helpers.contain(this.allowed, _level.Level.WARN)) return this;
            if (this.allowed.length === 0 || _helpers.Helpers.contain(this.allowed, _level.Level.WARN)) {
                for (var _len12 = arguments.length, data = Array(_len12 > 1 ? _len12 - 1 : 0), _key12 = 1; _key12 < _len12; _key12++) {
                    data[_key12 - 1] = arguments[_key12];
                }

                _display.Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, _level.Level.WARN, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: 'isProductionMode',
        get: function get() {
            return !this.developmentMode;
        }
    }]);

    return Logger;
}();
//# sourceMappingURL=logger.js.map